grammar Waifu;
// language modes?
// todo single letter id and number doesn't work

prog: func+;
/* expr: assign_expr
//   | '(' expr ')'
    | fun_call
    | ID SEP OP SEP expr
    | num_expr
    ;
*/
expr: 
    | NUM WS ADD WS NUM
    ;
func: '(' (ID WS TYPE)* ')' WS TYPE? ID NL
    (INDENT expr NL)+;
    
num_expr: SIGN? NUM;
assign_expr: ID WS ASSIGN WS expr;
fun_call: ID (WS expr)*;
op: (ADD | SUB | MULT | DIV);

SIGN: '+' | '-' ;
INDENT: '  ' ;
NL: '\n' ; 
WS: ' ' ;
ASSIGN: '<-';
ID: [a-zA-Z]+[a-zA-Z0-9]*;
LETTER: [a-zA-Z] ;
NUM: [0-9]+ ;
TYPE: ':' .+?;
OP: '+' | '-' | '*' | '/' ;

ADD: '+';
SUB: '-';
MULT: '*';
DIV: '/';

/*
prog: (func | expr)+ EOF;
func: FUNC_DECL SPACE ID NL (INDENT expr NL)+;
expr: paren_expr | assignment | num_expr | str_expr | fun_call | ID;
paren_expr: '(' expr ')';
assignment: ID SPACE ASSIGN SPACE expr;
num_expr: NUMERIC SPACE OP SPACE NUMERIC
    ; 
 
str_expr: V_STR
    | V_WHOLE MULT str_expr
    | str_expr MULT V_WHOLE
    | str_expr ADD str_expr
    ;
    
fun_call: ID (SPACE expr)+;

SPACE: ' ';
LETTER: [a-zA-Z];
ID: LETTER+;
ASSIGN: '<-' ;
FUNC_DECL: '()';
NL: '\n';
INDENT: '  ';
DIGIT : [0-9];
SIGN : '+' | '-';

ADD: '+' ;
SUB: '-' ;
DIV: '/' ;
MOD: '%' ;
MULT: '*' ;
OP: (ADD | SUB | DIV | MOD | MULT);

V_WHOLE : SIGN? DIGIT+;
V_DEC : V_WHOLE '.' DIGIT+;
V_BOOL : '1' | '0' ;

NUMERIC: V_WHOLE | V_DEC | V_BOOL;

V_STR : '\'' .*? '\'';
*/